@echo off
rem --- 'sdcreate.cmd' v2.7 by KdL (2019.08.03)

if "%~1"=="" color 1f&title SD Card preparing tool

:begin
if not exist "OS\MSXDOS2.SYS" (
    color f0&echo.&echo 'MSXDOS2.SYS' is missing!
    set TIMEOUT=1&goto quit_0
)
if not exist "OS\COMMAND2.COM" (
    color f0&echo.&echo 'COMMAND2.COM' is missing!
    set TIMEOUT=1&goto quit_0
)
call :title
wmic logicaldisk where drivetype=2 get deviceid, filesystem, volumename, size

rem --- Input parameters
:target
setlocal ENABLEDELAYEDEXPANSION
set TIMEOUT=1
set /p dest=Enter the target drive letter: 
if "%dest%"=="" endlocal&goto begin
set dest=%dest:~0,1%:
call :uppercase dest

set label=MSXFAT16
set /p label=Enter a label name (optional): 
set label=%label:~0,11%

rem --- Start of process
call :title
echo ### Ready to format the SD Card "%label%" (%dest%)
echo.
echo WARNING: ALL EXISTING DATA OF THE TARGET DEVICE WILL BE DESTROYED^^!
echo Press any key to continue...
pause >nul 2>nul

set dps=dpscript.tmp
set partsize=4095

:format
rem --- Create a partition if SD card is higher than 4GB
call :title
if "%retry%"=="" echo ### Formatting...
if not "%retry%"=="" color 5f&echo ### FORMATTING FAILED^^! Retrying...
echo.
echo >%dps% select volume=%dest:~0,1%
echo >>%dps% clean
echo >>%dps% create partition primary size=%partsize%
echo >>%dps% format fs=fat label="%label%" quick override
echo >>%dps% assign letter=%dest:~0,1%
diskpart /s %dps% >nul 2>&1
set sdbiostemp="%dest%\System Volume Information"
md %sdbiostemp% >nul 2>nul
if exist %sdbiostemp% goto is_higher

rem --- Create a partition if SD card is lower than 4GB
echo >%dps% select volume=%dest:~0,1%
echo >>%dps% clean
echo >>%dps% create partition primary
echo >>%dps% format fs=fat label="%label%" quick override
echo >>%dps% assign letter=%dest:~0,1%
diskpart /s %dps% >nul 2>&1
md %sdbiostemp% >nul 2>nul

rem --- Finalizing
:is_higher
del %dps% >nul 2>nul
if exist %sdbiostemp% set retry=off
if "%retry%"=="" set retry=err&goto format
if "%retry%"=="err" (
    color 4f&echo CRITICAL ERROR: THE TARGET DRIVE WAS NOT FOUND^^!
    waitfor /T %TIMEOUT% pause >nul 2>nul
    goto quit_0
)
set sdbiosfn=OCM-BIOS.DAT
rd /S /Q %sdbiostemp% >nul 2>nul&rem.>%sdbiostemp%
echo Starting EPBIOS is safer if you don't delete me^^!>>%sdbiostemp%
if exist SDBIOS\%sdbiosfn% copy /Y SDBIOS\%sdbiosfn% %sdbiostemp% >nul 2>nul
if exist %sdbiostemp% ren %sdbiostemp% %sdbiosfn% >nul 2>nul
if exist %dest%\%sdbiosfn% attrib +R +H +S %dest%\%sdbiosfn% >nul 2>nul
call :title
echo ### FORMATTING SUCCEEDED^^! Finalizing...
echo.
copy OS\MSXDOS2.SYS %dest% >nul 2>nul
copy OS\NEXTOR.SYS %dest% >nul 2>nul
copy OS\COMMAND2.COM %dest% >nul 2>nul
copy OS\AUTOEXEC.BAT %dest% >nul 2>nul
copy OS\REBOOT.BAT %dest% >nul 2>nul
md %dest%\HELP >nul 2>nul
md %dest%\UTILS >nul 2>nul
copy HELP\*.HLP %dest%\HELP >nul 2>nul
move /Y UTILS\__utils_subfolder_readme.txt >nul
copy UTILS\*.* %dest%\UTILS >nul 2>nul
move /Y __utils_subfolder_readme.txt UTILS >nul

rem --- End of process
echo Done^^!
:quit_0
waitfor /T %TIMEOUT% pause >nul 2>nul
goto quit

:uppercase
set %~1=!%1:a=A!
set %~1=!%1:b=B!
set %~1=!%1:c=C!
set %~1=!%1:d=D!
set %~1=!%1:e=E!
set %~1=!%1:f=F!
set %~1=!%1:g=G!
set %~1=!%1:h=H!
set %~1=!%1:i=I!
set %~1=!%1:j=J!
set %~1=!%1:k=K!
set %~1=!%1:l=L!
set %~1=!%1:m=M!
set %~1=!%1:n=N!
set %~1=!%1:o=O!
set %~1=!%1:p=P!
set %~1=!%1:q=Q!
set %~1=!%1:r=R!
set %~1=!%1:s=S!
set %~1=!%1:t=T!
set %~1=!%1:u=U!
set %~1=!%1:v=V!
set %~1=!%1:w=W!
set %~1=!%1:x=X!
set %~1=!%1:y=Y!
set %~1=!%1:z=Z!
goto:eof

:title
cls
echo OCM-SDCREATE v2.7  by KdL (2019.08.03)
echo ======================================
echo.
goto:eof

:quit
endlocal
