;
; *.*
;   OCM-EXTRA Pack / Switched I/O ports ($40-$4F) Revision 1 or later
;
; Copyright (c) 2011-2019 KdL
; All rights reserved.
;
; Redistribution and use of this source code or any derivative works, are
; permitted provided that the following conditions are met:
;
; 1. Redistributions of source code must retain the above copyright notice,
;    this list of conditions and the following disclaimer.
; 2. Redistributions in binary form must reproduce the above copyright
;    notice, this list of conditions and the following disclaimer in the
;    documentation and/or other materials provided with the distribution.
; 3. Redistributions may not be sold, nor may they be used in a commercial
;    product or activity without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
; TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
; PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
; CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
; EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;
; ----------------------------------------
;     Prog: OCM-SLOTMODE v1.3 by KdL
;     Date: 2019.04.15
;     Note: OCM-PLD Pack v2.4 or later
;     Coded in TWZ'CA3 w/ TASM80 v3.2ud
; ----------------------------------------
;

            .ORG  $0100

FN1         .EQU  's'                     ; strings and options
FN2         .EQU  'l'
FN3         .EQU  'o'
FN4         .EQU  't'
FN5         .EQU  'm'
FN6         .EQU  'o'
FN7         .EQU  'd'
FN8         .EQU  'e'
VER1        .EQU  '1'
VER2        .EQU  '3'
YR1         .EQU  '2'
YR2         .EQU  '0'
YR3         .EQU  '1'
YR4         .EQU  '9'
VERBOSE     .EQU  '/'
QUIET       .EQU  '-'
OPT1        .EQU  '0'
OPT2        .EQU  '1'
OPT3        .EQU  '2'
OPT4        .EQU  '3'
OPT5        .EQU  '4'
OPT6        .EQU  '5'
OPT7        .EQU  '6'
OPT8        .EQU  '7'
LOCK        .EQU  'l'
UNLOCK      .EQU  'u'
HLP1        .EQU  'h'
HLP2        .EQU  '?'

SCMDOPT1    .EQU  $0d
SCMDBASE    .EQU  OPT1-SCMDOPT1
SCMDLOCK    .EQU  $33
SCMDUNLK    .EQU  SCMDLOCK+1
SWIOADDR    .EQU  $40                     ; switched i/o port
SCMDADDR    .EQU  $41                     ; smart command port
REVADDR     .EQU  $4f
VDIPADDR    .EQU  $42                     ; virtual dip-sw port
LOCKADDR    .EQU  $43                     ; lock mask port
LINRADDR    .EQU  $4a
NULID       .EQU  $80
OCMID       .EQU  $d4                     ; ocm id

SLOTMASK    .EQU  %00111000               ; masks
MODE1       .EQU  %00001000
MODE2       .EQU  %00010000
MODE3       .EQU  %00011000
MODE4       .EQU  %00100000
MODE5       .EQU  %00101000
MODE6       .EQU  %00110000
SLOT1LOCK   .EQU  %00001000
SLOT2LOCK   .EQU  %00010000
CHKLINR1    .EQU  %01000000
CHKLINR2    .EQU  %10000000
LOWERCASE   .EQU  %00100000
UP          .EQU  -LOWERCASE
_           .EQU  %10000000               ; obfuscation mask, e.g. 'A'|_,'B'|_
DEOBF       .EQU  %01111111               ; de-obfuscation mask
REVMASK     .EQU  %00011111

NUL         .EQU  $00                     ; ascii table
LF          .EQU  $0a
CLS         .EQU  $0c
CR          .EQU  $0d
EOF         .EQU  $1a
SPC         .EQU  $20

PLENGHT     .EQU  $0080                   ; system calls
CALSLT      .EQU  $001c
CHPUT       .EQU  $00a2
EXPTBL      .EQU  $fcc1
_BDOS       .EQU  $0005
_STROUT     .EQU  $09                     ; string output

ONE         .EQU  $01                     ;   1 byte  for char
HLN         .EQU  $10                     ;  16 bytes for hex line
CLU         .EQU  $0100                   ; 256 bytes for cluster

K1          .EQU  'K'                     ; editable copyleft: 1st three chars
K2          .EQU  'd'
K3          .EQU  'L'
_1          .EQU  K1|_                    ; obfuscated copyleft
_2          .EQU  K2|_
_3          .EQU  K3|_
; ----------------------------------------
startProg:
            jr    mainProg                ; type support, A:\>TYPE FILENAME.COM
typeMsg:
;           .DB   CR,SPC,SPC,SPC,SPC,LF   ; 'jr mainProg' ctrl sequences mask
            .DB   CR,"OCM-"
            .DB   FN1+UP,FN2+UP,FN3+UP,FN4+UP,FN5+UP,FN6+UP,FN7+UP,FN8+UP
            .DB   " v",VER1,".",VER2," by "
clearCopyleft:
            .DB   K1,K2,K3," 2011-",YR1,YR2,YR3,YR4,CR
msgLF:
            .DB   LF,EOF
; ----------------------------------------
EXTRA:      .DB   NUL                     ; vars
; ----------------------------------------
mainProg:
            di
            ld    c,LF+ONE                ; init 'call strDisp' to use
            ld    d,NULID+SCMDBASE        ; reg d is 'OPTION'
            ld    e,VERBOSE               ; reg e is 'PREFIX'
copyleftChk:
            ld    hl,clearCopyleft
            ld    a,_1
            and   DEOBF                   ; de-obfuscation
            cp    (hl)
            jr    nz,copyleftNext         ; protection: 'K' is confirmed here
            inc   hl
            ld    a,_2
            and   DEOBF                   ; de-obfuscation
            cp    (hl)
copyleftNext:
            jr    nz,jrnzSPC              ; protection: 'd' is confirmed here
            inc   hl
            ld    a,_3
            and   DEOBF                   ; de-obfuscation
            cp    (hl)
jrnzSPC:
            jr    nz,noParam              ; protection: parameter down!
; ----------------------------------------
startParser:
            ld    hl,PLENGHT
            ld    b,(hl)
            ld    a,b
            cp    NUL
            jr    z,noParam               ; jump if no chars
            ld    a,(PLENGHT+ONE)
            cp    SPC                     ; ignore this policy:
            jr    nz,noParam              ; e.g. A:\>FILENAME/x
preLoop:
            inc   hl
            ld    a,(jrnzSPC)             ; protection: jrnzSPC = $20
            cp    (hl)
            jr    nz,getParam             ; get 1st parameter:
            djnz  preLoop                 ; e.g. A:\>FILENAME      -x
noParam:
            jr    ocmidChk                ; no parameters
getParam:
            ld    a,(hl)
            ld    e,a
            djnz  getOption               ; if no option, get invalid parameter
invalidParam:
            ld    hl,errorMsg0
            call  strDisp                 ; 'invalid parameter' without prefix
            jr    nearestExit             ; jump to the nearest exit, 2 bytes
getOption:
            inc   hl
            ld    a,(hl)
            or    LOWERCASE               ; 1st option forced to lowercase
            ld    d,a
            djnz  nextOption              ; if end of PLENGHT, parameter is get
            jr    prefixChk
nextOption:
            inc   hl
            ld    a,(hl)
            or    LOWERCASE               ; 2nd option forced to lowercase
            cp    LOCK
            jr    z,setOpt2               ; is 'l'
            cp    UNLOCK
            jr    nz,postLoop1            ; is other
setOpt2:
            ld    (EXTRA),a               ; is 'u'
            jr    postLoop2
postLoop:
            inc   hl
postLoop1:
            ld    a,(jrnzSPC)             ; protection: jrnzSPC = $20
            cp    (hl)
            jr    nz,invalidParam         ; get 2nd parameter as invalid:
postLoop2:
            djnz  postLoop                ; e.g. A:\>FILENAME -x    abcdef
prefixChk:
            ld    a,e
            cp    QUIET                   ; '-'
            jr    z,paramChk
            cp    VERBOSE                 ; '/'
            jr    nz,invalidParam
; ----------------------------------------
paramChk:
            ld    a,d
            sub   OPT1-ONE
            ld    b,OPT8-OPT1+ONE
optLoop:
            cp    b
            jr    z,ocmidChk              ; jump if '7' to '0' (loop 8 to 1)
            djnz  optLoop
            ld    a,(EXTRA)
            cp    b
            jr    nz,invalidParam         ; invalid with '/ll', '-?u', etc.
            ld    a,d
            cp    LOCK
            jr    z,extraOnly             ; jump if 'l'
            cp    UNLOCK
            jr    z,extraOnly             ; jump if 'u'
            cp    HLP1
            jr    z,isHelp                ; jump if 'h'
            cp    HLP2
            jr    nz,invalidOption        ; jump if '?'
isHelp:
            ld    hl,helpMsg              ; help message
nearestExit:
            jr    strExit
invalidOption:
            ld    hl,errorMsg0
            call  strDisp
            ld    hl,errorMsg2
            jr    strExit                 ; 'invalid option'
extraOnly:
            ld    (EXTRA),a               ; shift the option to extra
            ld    d,NULID+SCMDBASE        ; $80 is the null smart command
; ----------------------------------------
ocmidChk:
            ld    a,OCMID                 ; check for 1chipMSX ID
            out   (SWIOADDR),a
            in    a,(SWIOADDR)
            cpl
            cp    OCMID
; ----------------------------------------
            jr    nz,isUnsupp             ; 'unsupported command' (rem to test)
            in    a,(REVADDR)             ; revision check
            and   REVMASK
            cp    NUL                     ; = revision 0
            jr    z,isUnsupp              ; 'unsupported command' (jr nz to test)
; ----------------------------------------
            ld    b,8                     ; = revision 8, 7, 6, 5, 4, 3, 2, 1
testRev:
            cp    b
            jr    z,isOldRev              ; revision < 9 (jr nz to test)
            djnz  testRev
; ----------------------------------------
            ld    a,d
            jr    outScmd
isOldRev:
            ld    a,d
            ld    d,NUL                   ; cancels the linear check
outScmd:
            sub   SCMDBASE
            out   (SCMDADDR),a            ; set smart command
extraChk:
            ld    a,(EXTRA)
            cp    UNLOCK
            jr    nz,lockChk
            ld    a,SCMDUNLK
            jr    setExtra
lockChk:
            cp    LOCK
            jr    nz,quietChk
            ld    a,SCMDLOCK
setExtra:
            out   (SCMDADDR),a            ; lock slot toggles
quietChk:
            ld    a,e
            cp    QUIET
            jr    z,quietExit             ; quiet exit
; ----------------------------------------
            ld    hl,msgSlot1             ; '(1) '
isMsg0:
            call  strDisp
getStatus:
            in    a,(VDIPADDR)            ; get many states
            and   SLOTMASK                ; and filter for slot1 and slot2
            cp    NUL
            jr    nz,isMsg2               ; MODE0: VDIPADDR is 'xx000xxx'
isMsg1:
            ld    hl,msgEXT               ; 'External' (Slot1)
            jr    isEXT2
isMsg2:
            cp    MODE1
            jr    nz,isMsg3               ; MODE1: VDIPADDR is 'xx001xxx'
;           ld    hl,msgSCCI              ; 'SCC-I   ' (Slot1)
            call  isLinear1
isEXT2:
            call  strDisp
            call  isSlot2
;           ld    hl,msgEXT               ; 'External' (Slot2)
            jr    isLock                  ; display last string and exit
isUnsupp:
            ld    a,e
            cp    QUIET
quietExit:
            jp    z,mainExit              ; quiet exit (useful for batch)
            ld    hl,unsuppMsg            ; 'unsupported command' if '/' prefix
strExit:
            jr    lastDisp
isMsg3:
            cp    MODE2                   ; MODE2: VDIPADDR is 'xx010xxx'
            jr    nz,isMsg4
            ld    hl,msgEXT               ; 'External' (Slot1)
            jr    isSCC2
isMsg4:
            cp    MODE3                   ; MODE3: VDIPADDR is 'xx011xxx'
            jr    nz,isMsg5
;           ld    hl,msgSCCI              ; 'SCC-I   ' (Slot1)
            call  isLinear1
isSCC2:
            call  strDisp
            call  isSlot2
            ld    hl,msgSCCI              ; 'SCC-I   ' (Slot2)
            call  isLinear2
            jr    isLock
isSlot2:
            ld    hl,msgSlot2             ; '  (2) '
            jr    strDisp
isMsg5:
            cp    MODE4                   ; MODE4: VDIPADDR is 'xx100xxx'
            jr    nz,isMsg6
            ld    hl,msgEXT               ; 'External' (Slot1)
            jr    isASC8K
isMsg6:
            cp    MODE5                   ; MODE5: VDIPADDR is 'xx101xxx'
            jr    nz,isMsg7
;           ld    hl,msgSCCI              ; 'SCC-I   ' (Slot1)
            call  isLinear1
isASC8K:
            call  strDisp
            call  isSlot2
            ld    hl,msgASC8K             ; 'ASCII-8k' (Slot2)
            call  isLinear2
            jr    isLock
isMsg7:
            cp    MODE6                   ; MODE6: VDIPADDR is 'xx110xxx'
            jr    nz,isMsg8
            ld    hl,msgEXT               ; 'External' (Slot1)
            jr    isASC16
isMsg8:                                   ; MODE7: VDIPADDR is 'xx010xxx'
;           ld    hl,msgSCCI              ; 'SCC-I   ' (Slot1)
            call  isLinear1
isASC16:
            call  strDisp
            call  isSlot2
            ld    hl,msgASC16             ; 'ASCII-16k' (Slot2)
            call  isLinear2
isLock:
            call  strDisp
            ld    hl,msg0                 ; locate for slot2 message
            call  strDisp
            ld    b,SLOT2LOCK             ; slot2 locked/unlocked message
            call  strLock
            call  strDisp
            ld    b,SLOT1LOCK             ; slot1 locked/unlocked message
            call  strLock
; ----------------------------------------
lastDisp:
            dec   c                       ; use 'jr lastDisp' or 'jp lastDisp'
strDisp:
            inc   c                       ; use 'call strDisp'
charLoop:
            ld    a,(hl)                  ; load 1st char, ascii < 127 only
            and   DEOBF                   ; de-obfuscation
            ld    ix,CHPUT                ; init chput
            ld    iy,(EXPTBL-1)           ; init main-rom slot
            call  CALSLT                  ; NUL and EOF are not valid as 1st
            inc   hl
            xor   a
            cp    (hl)
            jr    nz,nextChar             ; NUL,n = SPC(n)
            inc   hl
            ld    b,(hl)                  ; b = n
            ld    a,(jrnzSPC)             ; protection: jrnzSPC = $20
;           and   DEOBF                   ; de-obfuscation (optional)
spcLoop:
            ld    ix,CHPUT                ; init chput
            ld    iy,(EXPTBL-1)           ; init main-rom slot
            call  CALSLT                  ; print SPC until b = 0
            djnz  spcLoop
            inc   hl
nextChar:
            ld    a,EOF
            cp    (hl)
            jr    nz,charLoop             ; EOF = end of string
            inc   hl                      ; point to the next string at exit
            dec   c
            ld    a,LF
            cp    c                       ; c = LF is 'lastDisp'
            ret   nz                      ; exit of 'strDisp'
            ld    de,strLFCR              ; print LF + CR after 'lastDisp'
            ld    c,_STROUT               ; 'OPTION' and 'PREFIX' will be lost
            call  _BDOS
mainExit:
            xor   a
            ld    (PLENGHT),a             ; reset PLENGHT for the next command
            ei
            ret
strLFCR:
            .DB   LF,CR,'$'
; ----------------------------------------
strLock:
            in    a,(LOCKADDR)
            and   b                       ; b is required as lock mask here
            cp    NUL
            jr    z,msgUnlock
            ld    hl,lockMsg
            ret
msgUnlock:
            ld    hl,unlockMsg
            ret
; ----------------------------------------
isLinear1:
            in    a,(LINRADDR)
            and   CHKLINR1                ; 'x1xxxxxx' (Slot1)
            jr    isLinear
isLinear2:
            in    a,(LINRADDR)
            and   CHKLINR2                ; '1xxxxxxx' (Slot2)
isLinear:
            cp    NUL
            ret   z
            ld    a,d
            cp    NUL
            ret   z
            ld    hl,msgLinear            ; 'Linear  '
            ret
; ----------------------------------------
helpMsg:                                  ; texts comply with 37 columns
            .DB   LF|_
            .DB   CLS|_,'S'|_,'y'|_,'n'|_,'t'|_,'a'|_,'x'|_,':'|_,' '|_
            .DB   FN1|_,FN2|_,FN3|_,FN4|_,FN5|_,FN6|_,FN7|_,FN8|_,' '|_
            .DB   '['|_,'{'|_,VERBOSE|_,'|'|_,QUIET|_,'}'|_
            .DB   'o'|_,'p'|_,'t'|_,'i'|_,'o'|_,'n'|_
            .DB   '['|_,'l'|_,'|'|_,'u'|_,']'|_,']'|_
            .DB   LF|_

            .DB   LF|_,CR|_,'N'|_,'o'|_,' '|_
            .DB   'p'|_,'a'|_,'r'|_,'a'|_,'m'|_,'e'|_,'t'|_,'e'|_,'r'|_,':'|_
            .DB   NUL,4,'S'|_,'h'|_,'o'|_,'w'|_,'s'|_,' '|_,'t'|_,'h'|_,'e'|_
            .DB   ' '|_,'s'|_,'t'|_,'a'|_,'t'|_,'u'|_,'s'|_
            .DB   LF|_

            .DB   LF|_,CR|_
            .DB   'P'|_,'r'|_,'e'|_,'f'|_,'i'|_,'x'|_,'e'|_,'s'|_,':'|_
            .DB   NUL,4,VERBOSE|_,NUL,3
            .DB   'V'|_,'e'|_,'r'|_,'b'|_,'o'|_,'s'|_,'e'|_,' '|_
            .DB   'o'|_,'u'|_,'t'|_,'p'|_,'u'|_,'t'|_
            .DB   LF|_,CR|_,NUL,13,QUIET|_,NUL,3
            .DB   'Q'|_,'u'|_,'i'|_,'e'|_,'t'|_,' '|_
            .DB   'o'|_,'u'|_,'t'|_,'p'|_,'u'|_,'t'|_
            .DB   LF|_

            .DB   LF|_,CR|_,'O'|_,'p'|_,'t'|_,'i'|_,'o'|_,'n'|_,'s'|_,':'|_
            .DB   NUL,9,'S'|_,'l'|_,'o'|_,'t'|_,'1'|_
            .DB   NUL,3,'S'|_,'l'|_,'o'|_,'t'|_,'2'|_
            .DB   LF|_,CR|_,NUL,13,OPT1|_
            .DB   NUL,4,'-'|_,'-'|_,'-'|_,NUL,5,'-'|_,'-'|_,'-'|_
            .DB   LF|_,CR|_,NUL,13,OPT2|_
            .DB   NUL,3,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_,NUL,4,'-'|_,'-'|_,'-'|_
            .DB   LF|_,CR|_,NUL,13,OPT3|_
            .DB   NUL,4,'-'|_,'-'|_,'-'|_,NUL,4,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_
            .DB   LF|_,CR|_,NUL,13,OPT4|_
            .DB   NUL,3,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_
            .DB   NUL,3,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_
            .DB   LF|_,CR|_,NUL,13,OPT5|_
            .DB   NUL,4,'-'|_,'-'|_,'-'|_
            .DB   NUL,4,'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'8'|_,'k'|_
            .DB   LF|_,CR|_,NUL,13,OPT6|_
            .DB   NUL,3,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_
            .DB   NUL,3,'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'8'|_,'k'|_
            .DB   LF|_,CR|_,NUL,13,OPT7|_
            .DB   NUL,4,'-'|_,'-'|_,'-'|_
            .DB   NUL,4,'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'1'|_,'6'|_,'k'|_
            .DB   LF|_,CR|_,NUL,13,OPT8|_
            .DB   NUL,3,'S'|_,'C'|_,'C'|_,'-'|_,'I'|_
            .DB   NUL,3,'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'1'|_,'6'|_,'k'|_
            .DB   LF|_

            .DB   LF|_,CR|_,'E'|_,'x'|_,'t'|_,'r'|_,'a'|_,'s'|_,':'|_,NUL,6
            .DB   LOCK,NUL,3,'T'|_,'o'|_,'g'|_,'g'|_,'l'|_,'e'|_,'s'|_,' '|_
            .DB   'l'|_,'o'|_,'c'|_,'k'|_,'e'|_,'d'|_,LF|_,CR|_,NUL,13,UNLOCK
            .DB   NUL,3,'T'|_,'o'|_,'g'|_,'g'|_,'l'|_,'e'|_,'s'|_,' '|_
            .DB   'u'|_,'n'|_,'l'|_,'o'|_,'c'|_,'k'|_,'e'|_,'d'|_
            .DB   LF|_

            .DB   LF|_,CR|_
            .DB   'E'|_,'x'|_,'a'|_,'m'|_,'p'|_,'l'|_,'e'|_,'s'|_,':'|_
            .DB   NUL,8,FN1|_,FN2|_,FN3|_,FN4|_,FN5|_,FN6|_,FN7|_,FN8|_,' '|_
            .DB   VERBOSE|_,UNLOCK|_,LF|_,CR|_
            .DB   NUL,17,FN1|_,FN2|_,FN3|_,FN4|_,FN5|_,FN6|_,FN7|_,FN8|_,' '|_
            .DB   QUIET|_,OPT5|_,LOCK|_

            .DB   EOF
msgSlot1:
            .DB   '('|_,'1'|_,')'|_,' '|_,EOF
msgSCCI:
            .DB   'S'|_,'C'|_,'C'|_,'-'|_,'I'|_,NUL,3,EOF
msgSlot2:
            .DB   ' '|_,'('|_,'2'|_,')'|_,' '|_,EOF
msgEXT:
            .DB   'E'|_,'x'|_,'t'|_,'e'|_,'r'|_,'n'|_,'a'|_,'l'|_,EOF
msgASC8K:
            .DB   'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'8'|_,'k'|_,EOF
msgASC16:
            .DB   'A'|_,'S'|_,'C'|_,'I'|_,'I'|_,'-'|_,'1'|_,'6'|_,'k'|_,EOF
msgLinear:
            .DB   'L'|_,'i'|_,'n'|_,'e'|_,'a'|_,'r'|_,NUL,2,EOF
msg0:
            .DB   LF|_,CR|_,NUL,17,EOF
unlockMsg:
            .DB   'u'|_,'n'|_
lockMsg:
            .DB   'l'|_,'o'|_,'c'|_,'k'|_,'e'|_,'d'|_,CR|_,NUL,4,EOF
errorMsg0:
            .DB   LF|_,'*'|_,'*'|_,'*'|_,' '|_
            .DB   'I'|_,'n'|_,'v'|_,'a'|_,'l'|_,'i'|_,'d'|_,' '|_,EOF
errorMsg1:
            .DB   'p'|_,'a'|_,'r'|_,'a'|_,'m'|_,'e'|_,'t'|_,'e'|_,'r'|_,EOF
errorMsg2:
            .DB   'o'|_,'p'|_,'t'|_,'i'|_,'o'|_,'n'|_,EOF
unsuppMsg:
            .DB   LF|_,'*'|_,'*'|_,'*'|_,' '|_
            .DB   'U'|_,'n'|_,'s'|_,'u'|_,'p'|_,'p'|_,'o'|_,'r'|_,'t'|_,'e'|_
            .DB   'd'|_,' '|_,'c'|_,'o'|_,'m'|_,'m'|_,'a'|_,'n'|_,'d'|_,EOF
; ----------------------------------------
startFill:                                ; $FF fill the 1st hex line
            .FILL ((((startFill-startProg)/HLN)+ONE)*HLN-(startFill-startProg))
endProg:                                  ; $FF fill the cluster
;           .FILL ((((endProg-startProg)/CLU)+ONE)*CLU-(endProg-startProg))-HLN
                                          ; [ FILENAME.COM ] at last hex line
            .DB   "[ ",FN1+UP,FN2+UP,FN3+UP,FN4+UP,FN5+UP,FN6+UP,FN7+UP,FN8+UP
            .DB   ".COM ]"

            .END
